# 安卓正向安全

此处主要介绍：

* 安卓的 **正向**=**安全**
  * 防静态分析
    * 防砸壳：`加固`
      * 加固手段的发展历史
      * `加壳`
    * 防反编译
      * 代码混淆
        * `Proguard`
        * `Ollvm`
  * 防动态调试
    * 防调试和运行
      * 反调试
      * Root检测
        * 检测`Xposed`、`Frida`等
    * 防抓包=反抓包
      * `ssl pinning`=`证书绑定`

## 如何防护安卓的安全

* 首要的：加强业务逻辑
  * api接口通讯
    * 全部接口都实现https
      * 且做`证书绑定`=`ssl pinning`
* 其次：加强安全防破解技术
  * 代码
    * 代码混淆
      * 首选：`Obfuscator-LLVM`=`ollvm`
      * 其次：`ProGuard`
  * 其他防护
    * `VMP`
      * 给`dex`（中的核心逻辑）做VMP
      * 给`so`库（中的核心逻辑）做VMP
    * 加壳
      * 用第三方加壳服务或自己实现
        * 第三方加壳服务商
          * 腾讯乐固legu
          * 360加固保
          * 网易易盾
          * 等
